<?php

/*
        zbozicz_2010.php
        
        Changelog:
        -
        - 2010-03-20 compatible with OpenCart 1.4.4 -> berushka.net <me@berushka.net>
        - 2010-03-19 disable non-active product -> berushka.net <me@berushka.net>
        - 2010-03-16 VARIANT (added DELIVERY_DATE and PRICE) -> berushka.net <me@berushka.net>
        - 2010-03-11 url_alias
        - 2010-03-04 VARIANT (only name) -> berushka.net <me@berushka.net>
        - 2010-03-03 PRICE_VAT (excl. tax), product URL v1.4.0, product_name()
        - 2010-02-19 DELIVERY_DATE
        - 2010-02-19 product price discount
        - 2010-06-05 VARIANT (rewrite) -> DJDaca <djdaca@seznam.cz>
        - 2010-06-05 xml cache

        Copyright 2010 Lukas Potesil <Pot'a>; <lukas@hostingsolutions.cz>
        
        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.
        
        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.
        
        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
        MA 02110-1301, USA.
*/

	/* debug
	ini_set('error_reporting', 6143);
	ini_set('display_errors', 1);
	*/
class Product {
	function description($product_description) {
		$product_description = str_replace('&amp;', '&', $product_description);
		$product_description = htmlspecialchars(strip_tags(html_entity_decode($product_description, ENT_QUOTES, 'UTF-8')));
		$product_description = str_replace('&amp;nbsp;', '', $product_description);
		/*$product_description = str_replace('&;', '&amp;', $product_description);*/
		if (strlen($product_description) > 508) {
			$print_description = substr($product_description, 0, 508);
			$pos = strrpos($print_description, ' ');
			$print_description = substr($product_description, 0, $pos) . ' ...';
		} else {
			$print_description = $product_description;
		}
		return $print_description;
	}

	function name($product_name) {
		$product_name = htmlspecialchars(strip_tags(html_entity_decode($product_name, ENT_QUOTES, 'UTF-8')));
		if (strlen($product_name) > 60) {
			$print_product_name = substr($product_name, 0, 60);
			$pos = strrpos($print_product_name, ' ');
			$print_product_name = substr($product_name, 0, $pos) . ' ...';
		} else {
			$print_product_name = $product_name;
		}
		return $print_product_name;
	}
}

require_once("./config.php");
require_once(DIR_SYSTEM . 'startup.php');
require_once(DIR_DATABASE . 'mysql.php');
$need_configs = array(
	'config_url',
	'config_ssl',
	'config_customer_group_id',
	'config_language'
);


// Config
$config = new Config();
$db = new DB(DB_DRIVER, DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);
$setting_query = $db->query("SELECT * FROM " . DB_PREFIX . "setting s WHERE s.key IN('".implode("','",$need_configs)."')");
foreach ($setting_query->rows as $setting) {
	$config->set($setting['key'], $setting['value']);
}
unset($setting_query);

//W.Z. get factor for currency

$sql = ("SELECT * FROM " . DB_PREFIX . "currency c WHERE c.code = 'CZK'");
		$result = $db->query( $sql );
		if ($result->rows) {
			foreach ($result->rows as $row) {
				$curr_factor = $row['value'];
				break;
			}
		}

//end W.Z.


// Cache
$cache = new Cache();
header('Expires: ' . gmdate('D, d M Y H:i:s') . '  GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . '  GMT');
header('Content-Type: application/xml');
$data = $cache->get('zbozicz');
if(!$data) {
	$items = new Product();
	define('HTTP_SERVER', $config->get('config_url')); 
	define('HTTP_IMAGE', HTTP_SERVER . 'image/');
	if ($config->get('config_ssl')) {
		define('HTTPS_SERVER', 'https://' . substr($config->get('config_url'), 0, 7));
		define('HTTPS_IMAGE', HTTPS_SERVER . 'image/');
	} else {
		define('HTTPS_SERVER', HTTP_SERVER);
		define('HTTPS_IMAGE', HTTP_IMAGE);
	}

	$url_query = $db->query("SELECT query,keyword FROM " . DB_PREFIX . "url_alias ORDER BY url_alias_id");
	$urls = array();
	foreach($url_query->rows as $url) {
		$data = array();
		parse_str($url['query'], $data);
		if(key($data) == 'product_id') {
			$urls[$data['product_id']] = $url['keyword'];
		}
	}
	unset($url_query);
	$SQL = "SELECT DISTINCT
		p.product_id,p.quantity,p.image,p.date_available,pd.language_id,pd.name,pd.description,pd.meta_description,
		tr.rate,tr.tax_class_id,ss.name AS product_status,ss.stock_status_id,m.name AS manufacturer,
		IF(ps.price,ps.price,p.price) AS price

		FROM " . DB_PREFIX . "product p
		LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id=pd.product_id) 
		LEFT JOIN " . DB_PREFIX . "tax_rate tr ON (p.tax_class_id = tr.tax_class_id)
		LEFT JOIN " . DB_PREFIX . "stock_status ss ON (p.stock_status_id = ss.stock_status_id)
		LEFT JOIN " . DB_PREFIX . "language l ON (l.language_id = pd.language_id )
		LEFT JOIN " . DB_PREFIX . "manufacturer m ON (m.manufacturer_id = p.manufacturer_id )
		LEFT JOIN " . DB_PREFIX . "product_special ps ON (ps.product_id = p.product_id AND ps.customer_group_id=".$config->get('config_customer_group_id').")
	
		WHERE l.code='".$config->get('config_language')."' AND p.status=1";

	$head = "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\r";
	$head .= "<SHOP>\r";
	echo $head;
	$body = "";
	$query_products = $db->query($SQL);
	foreach ($query_products->rows as $product) {
		$shopitem = "";
		$shopitem .= "<SHOPITEM>\n";
		$shopitem .= "<PRODUCT>".$items->name($product['name'])."</PRODUCT>\n";
		if (!empty($product['meta_description'])) {
			$shopitem .= "<PRODUCTNAME>".htmlspecialchars(strip_tags(html_entity_decode($product['meta_description'], ENT_QUOTES, 'UTF-8')))."</PRODUCTNAME>\n";
		}
		$shopitem .= "<DESCRIPTION>".$items->description($product['description'])."</DESCRIPTION>";
		if ($product['quantity']>0) {
			// zboží na skladě
			$shopitem .= "<DELIVERY_DATE>0</DELIVERY_DATE>";
		} elseif(strtotime($product['date_available'])) {
			// zboží není na skladě
			$shopitem .= " <DELIVERY_DATE>".$product['date_available']."</DELIVERY_DATE>";
		}
		if ($product['manufacturer']) {
			$shopitem .= "<MANUFACTURER>".$product['manufacturer']."</MANUFACTURER>";
		}

		$shopitem .= "<URL>";
		if($urls[$product['product_id']]) {
			$shopitem .= HTTP_SERVER . $urls[$product['product_id']] . "/";
		} else {
			$shopitem .= HTTP_SERVER . "index.php?route=product/product&amp;product_id=". $product['product_id'];
		}
		$shopitem .= "</URL>";
		if (!$product['image']==0) {
			$shopitem .= "<IMGURL>". HTTPS_IMAGE . $product['image']."</IMGURL>";
		}
		//$shopitem .= "<FACTOR>" curr_factor() "</FACTOR>\n";
		if (!$product['tax_class_id']==0) {
			$shopitem .= "<PRICE>".round($product['price'] * $curr_factor, 2)."</PRICE>\n";
			$shopitem .= "<VAT>".round($product['rate'], 3)."</VAT>\n";
			$shopitem .= "<PRICE_VAT>".ceil($product['price'] * $curr_factor + (($product['price'] * $curr_factor) * $product['rate'] / 100))."</PRICE_VAT>\n";
		} else {
			$shopitem .= "<PRICE_VAT>".round($product['price'] * $curr_factor, 0)."</PRICE_VAT>";
		}
	
		$SQL = "SELECT ov.quantity, ov.price, ovd.name as value, od.name FROM " .
		DB_PREFIX . "product_option_value ov, " .
		DB_PREFIX . "product_option_value_description ovd, " .
		DB_PREFIX . "product_option_description od " .
		"WHERE ov.product_option_value_id = ovd.product_option_value_id AND " .
		"ov.product_option_id = od.product_option_id AND " .
		"od.product_id = " . intval($product['product_id']) . " AND " .
		"od.language_id=" . intval($product['language_id']) ;
		$query_product_option = $db->query($SQL);
		// VARIANT
		foreach ($query_product_option->rows as $product_option) {
			$shopitem .= "<VARIANT>";
			$shopitem .= "<PRODUCTNAMEEXT>" . $items->name($product_option['name']) . " " . $items->name($product_option['value']) . "</PRODUCTNAMEEXT>";
			if ($product_option['quantity']>0) {
				// zboží na skladě
				$shopitem .= "<DELIVERY_DATE>0</DELIVERY_DATE>";
			} elseif(strtotime($product['date_available'])) {
				// zboží není na skladě
				$shopitem .= "<DELIVERY_DATE>" . $product['date_available'] . "</DELIVERY_DATE>";
			}
			if (!$product['tax_class_id']==0) {
				$shopitem .= "<PRICE>".round($product['price'] * $curr_factor, 2)."</PRICE>\n";
				$shopitem .= "<VAT>".round($product['rate'], 3)."</VAT>\n";
				$shopitem .= "<PRICE_VAT>".ceil($product['price'] * $curr_factor + (($product['price'] * $curr_factor) * $product['rate'] / 100))."</PRICE_VAT>\n";
			} else {
				$shopitem .= "<PRICE_VAT>".round($product['price'] * $curr_factor + $product_option['price'] * $curr_factor, 0)."</PRICE_VAT>";
			}
			$shopitem .= "</VARIANT>\n";
		}
		unset($query_product_option);                                    
		$shopitem .= "</SHOPITEM>\n";
		$body .= $shopitem;
		echo $shopitem;
	}
	unset($query_products);
	$footer = "</SHOP>\r";
	echo $footer;
	//$cache->set('zbozicz', $head.$body.$footer);
} else {
	echo $data;
}
?>
